package com.famoco.scanenginetestapp.ui.general_settings;

import androidx.lifecycle.ViewModel;

import com.famoco.scanengine.ScanEngine;
import com.famoco.scanenginetestapp.data.PreferencesManager;
import com.famoco.scanenginetestapp.utils.ScanEngineProvider;

import java.util.Set;

public class GeneralSettingsViewModel extends ViewModel {
    private static final String TAG = GeneralSettingsViewModel.class.getSimpleName();

    public GeneralSettingsViewModel() {
        // nothing to do
    }

    public String getTriggerMode() {
        return PreferencesManager.getInstance().getTriggerMode();
    }

    public void setTriggerMode(String triggerMode) {
        PreferencesManager.getInstance().setTriggerMode(triggerMode);
    }

    public String getRereadDelay() {
        return PreferencesManager.getInstance().getRereadDelay();
    }

    public void setRereadDelay(String rereadDelay) {
        PreferencesManager.getInstance().setRereadDelay(rereadDelay);
        ScanEngine.ManualTriggerRereadDelay delay = ScanEngine.ManualTriggerRereadDelay.NO_DELAY;
        switch (rereadDelay) {
            case "1":
                delay = ScanEngine.ManualTriggerRereadDelay.DELAY_500_MS;
                break;
            case "2":
                delay = ScanEngine.ManualTriggerRereadDelay.DELAY_2000_MS;
                break;
        }
        ScanEngineProvider.getInstance()
                .setManualTriggerModeRereadDelay(delay);
    }

    public boolean getEnableAllSymbologies() {
        return PreferencesManager.getInstance().getEnableAllSymbologies();
    }

    public void setEnableAllSymbologies(boolean enable) {
        PreferencesManager.getInstance().setEnableAllSymbologies(enable);
    }

    public Set<String> getEnableSymbologies() {
        return PreferencesManager.getInstance().getEnableSymbologies();
    }

    public void setEnableSymbologies(Set<String> symbologies) {
        PreferencesManager.getInstance().setEnableSymbologies(symbologies);
    }

    public boolean getSupportInverseColorDetection() {
        return PreferencesManager.getInstance().getSupportInverseColorDetection();
    }

    public void setSupportInverseColorDetection(boolean support) {
        PreferencesManager.getInstance().setSupportInverseColorDetection(support);
    }

    public boolean getInverseColorDetectionOnly() {
        return PreferencesManager.getInstance().getInverseColorDetectionOnly();
    }

    public void setInverseColorDetectionOnly(boolean activateOnly) {
        PreferencesManager.getInstance().setInverseColorDetectionOnly(activateOnly);
    }

    public boolean getActivateIlluminationLevel() {
        return PreferencesManager.getInstance().getActivateIlluminationLevel();
    }

    public void setActivateIlluminationLevel(boolean activate) {
        PreferencesManager.getInstance().setActivateIlluminationLevel(activate);
    }

    public String getIlluminationLevel() {
        return PreferencesManager.getInstance().getIlluminationLevel();
    }

    public void setIlluminationLevel(String illuminationLevel) {
        PreferencesManager.getInstance().setIlluminationLevel(illuminationLevel);
    }

    public boolean getLockConfiguration() {
        return PreferencesManager.getInstance().getLockConfiguration();
    }

    public void setLockConfiguration(boolean lock) {
        PreferencesManager.getInstance().setLockConfiguration(lock);
    }

    public boolean getNoDataDisplay() {
        return PreferencesManager.getInstance().getNoDataDisplay();
    }

    public void setNoDataDisplay(boolean display) {
        PreferencesManager.getInstance().setNoDataDisplay(display);
    }

    public int getDetectionTimeout() {
        return PreferencesManager.getInstance().getDetectionTimeout();
    }

    public void setDetectionTimeout(int timeout) {
        PreferencesManager.getInstance().setDetectionTimeout(timeout);
    }
}
