package com.famoco.scanenginetestapp.ui.main_menu;

import androidx.lifecycle.LiveData;
import androidx.lifecycle.ViewModel;

import com.famoco.scanenginetestapp.utils.ScanEngineProvider;

public class MainMenuViewModel extends ViewModel {
    private static final String TAG = MainMenuViewModel.class.getSimpleName();

    public final LiveData<String> firmwareVersion =
            ScanEngineProvider.getInstance().firmwareVersion;
    public final LiveData<String> barcodeData = ScanEngineProvider.getInstance().barcodeData;
    public final LiveData<ScanEngineProvider.EngineState> scanningStateManual =
            ScanEngineProvider.getInstance().manualScanningState;

    public MainMenuViewModel() {
        // nothing to do
    }

    public void configure() {
        ScanEngineProvider.getInstance().configure();
    }

    public void startBarcodeDetection() {
        ScanEngineProvider.getInstance().startDetection();
    }

    public void stopBarcodeDetection() {
        ScanEngineProvider.getInstance().stopDetection();
    }
}
